import { system, world } from '@minecraft/server';
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';

const WhitePlants = [
    {
        id: 'bamboo_shoot',
        mint: 'spear',
        cost: 175
    },
    {
        id: 'cabbage_pult',
        mint: 'arma',
        cost: 100
    },
    {
        id: 'chili_bean',
        mint: 'ail',
        cost: 50
    },
    {
        id: 'coffee_bean',
        mint: 'enchant',
        cost: 25
    },
    {
        id: 'dripping_diphylleia',
        mint: 'winter',
        cost: 50
    },
    {
        id: 'droplet_shooter',
        mint: 'winter',
        cost: 100
    },
    {
        id: 'fire_gourd',
        mint: 'peper',
        cost: 200
    },
    {
        id: 'flat_shroom',
        mint: 'reinforce',
        cost: 0
    },
    {
        id: 'flower_pot',
        mint: 'contain',
        cost: 25
    },
    {
        id: 'flying_pot',
        mint: 'contain',
        cost: 25
    },
    {
        id: 'fume_shroom',
        mint: 'ail',
        cost: 125
    },
    {
        id: 'grave_devouring_vine',
        mint: 'contain',
        cost: 0
    },
    {
        id: 'groundcherry',
        mint: 'enlighten',
        cost: 25
    },
    {
        id: 'heavenly_peach',
        mint: 'reinforce',
        cost: 125
    },
    {
        id: 'iceberg_lettuce',
        mint: 'winter',
        cost: 0
    },
    {
        id: 'kernel_pult',
        mint: 'arma',
        cost: 100
    },
    {
        id: 'lily_pad',
        mint: 'contain',
        cost: 25
    },
    {
        id: 'magnet_shroom',
        mint: 'contain',
        cost: 100
    },
    {
        id: 'peashooter',
        mint: 'appease',
        cost: 100
    },
    {
        id: 'plantern',
        mint: 'enlighten',
        cost: 25
    },
    {
        id: 'potato_mine',
        mint: 'bombard',
        cost: 25
    },
    {
        id: 'puff_shroom',
        mint: 'ail',
        cost: 0
    },
    {
        id: 'resistant_radish',
        mint: 'reinforce',
        cost: 50
    },
    {
        id: 'spikeweed',
        mint: 'spear',
        cost: 100
    },
    {
        id: 'split_pea',
        mint: 'appease',
        cost: 125
    },
    {
        id: 'sprout',
        mint: 'enchant',
        cost: 0
    },
    {
        id: 'sun_bean',
        mint: 'enlighten',
        cost: 50
    },
    {
        id: 'sunflower',
        mint: 'enlighten',
        cost: 50
    },
    {
        id: 'tangle_kelp',
        mint: 'enforce',
        cost: 25
    },
    {
        id: 'timid_thorns',
        mint: 'reinforce',
        cost: 0
    },
    {
        id: 'wall_nut',
        mint: 'reinforce',
        cost: 50
    },
    {
        id: 'water_gun_grass',
        mint: 'winter',
        cost: 25
    }
];

const GreenPlants = [
    {
        id: 'anthurium',
        mint: 'fila',
        cost: 150
    },
    {
        id: 'bloomerang',
        mint: 'spear',
        cost: 175
    },
    {
        id: 'explode_o_nut',
        mint: 'bombard',
        cost: 50
    },
    {
        id: 'fire_peashooter',
        mint: 'peper',
        cost: 175
    },
    {
        id: 'garlic',
        mint: 'ail',
        cost: 50
    },
    {
        id: 'giant_sunflower',
        mint: 'enlighten',
        cost: 50
    },
    {
        id: 'giant_wall_nut',
        mint: 'reinforce',
        cost: 50
    },
    {
        id: 'goop_shroom',
        mint: 'ail',
        cost: 175
    },
    {
        id: 'grave_buster',
        mint: 'contain',
        cost: 75
    },
    {
        id: 'jackfruit',
        mint: 'reinforce',
        cost: 75
    },
    {
        id: 'lightning_reed',
        mint: 'fila',
        cost: 125
    },
    {
        id: 'machine_gun_pomegranate',
        mint: 'appease',
        cost: 325
    },
    {
        id: 'marigold',
        mint: 'enlighten',
        cost: 50
    },
    {
        id: 'melon_pult',
        mint: 'arma',
        cost: 325
    },
    {
        id: 'moonflower',
        mint: 'conceal',
        cost: 75
    },
    {
        id: 'rafflesia',
        mint: 'bombard',
        cost: 350
    },
    {
        id: 'rotating_pineapple',
        mint: 'reinforce',
        cost: 75
    },
    {
        id: 'sea_shroom',
        mint: 'ail',
        cost: 0
    },
    {
        id: 'snow_pea',
        mint: 'winter',
        cost: 150
    },
    {
        id: 'spikerock',
        mint: 'spear',
        cost: 250
    },
    {
        id: 'sweet_pea',
        mint: 'appease',
        cost: 200
    },
    {
        id: 'tall_nut',
        mint: 'reinforce',
        cost: 125
    },
    {
        id: 'threepeater',
        mint: 'appease',
        cost: 300
    },
    {
        id: 'torchwood',
        mint: 'appease',
        cost: 175
    },
    {
        id: 'umbrella_leaf',
        mint: 'contain',
        cost: 100
    },
    {
        id: 'wax_gourd_guard',
        mint: 'reinforce',
        cost: 125
    }
]

const BluePlants = [
    {
        id: 'asparagus',
        mint: 'appease',
        cost: 125
    },
    {
        id: 'blover',
        mint: 'contain',
        cost: 50
    },
    {
        id: 'bonk_choy',
        mint: 'enforce',
        cost: 150
    },
    {
        id: 'cherry_bomb',
        mint: 'bombard',
        cost: 150
    },
    {
        id: 'cherry_hover_bomb',
        mint: 'bombard',
        cost: 175
    },
    {
        id: 'chomper',
        mint: 'enforce',
        cost: 150
    },
    {
        id: 'cold_slaw',
        mint: 'arma',
        cost: 200
    },
    {
        id: 'giant_marigold',
        mint: 'enlighten',
        cost: 50
    },
    {
        id: 'hypno_shroom',
        mint: 'enlighten',
        cost: 75
    },
    {
        id: 'jalapeno',
        mint: 'peper',
        cost: 100
    },
    {
        id: 'laser_bean',
        mint: 'spear',
        cost: 100
    },
    {
        id: 'nitro_shroom',
        mint: 'ail',
        cost: 100
    },
    {
        id: 'oxygen_algae',
        mint: 'reinforce',
        cost: 50
    },
    {
        id: 'phat_beet',
        mint: 'enforce',
        cost: 150
    },
    {
        id: 'power_lily',
        mint: 'enchant',
        cost: 175
    },
    {
        id: 'pretty_plum',
        mint: 'appease',
        cost: 225
    },
    {
        id: 'primal_peashooter',
        mint: 'appease',
        cost: 175
    },
    {
        id: 'pumpkin',
        mint: 'reinforce',
        cost: 100
    },
    {
        id: 'repeater',
        mint: 'appease',
        cost: 200
    },
    {
        id: 'reverse_repeater',
        mint: 'appease',
        cost: 200
    },
    {
        id: 'shadow_shroom',
        mint: 'conceal',
        cost: 50
    },
    {
        id: 'snow_cotton',
        mint: 'winter',
        cost: 175
    },
    {
        id: 'squash',
        mint: 'enforce',
        cost: 50
    },
    {
        id: 'starfruit',
        mint: 'appease',
        cost: 150
    },
    {
        id: 'twin_sunflower',
        mint: 'enlighten',
        cost: 125
    }
]

const PurplePlants = [
    {
        id: 'ball_cactus',
        mint: 'arma',
        cost: 150
    },
    {
        id: 'bamboo_shoots',
        mint: 'contain',
        cost: 250
    },
    {
        id: 'black_eyed_pea',
        mint: 'enforce',
        cost: 100
    },
    {
        id: 'calm_chuck',
        mint: 'reinforce',
        cost: 75
    },
    {
        id: 'cattail',
        mint: 'spear',
        cost: 225
    },
    {
        id: 'corn_mortar',
        mint: 'arma',
        cost: 500
    },
    {
        id: 'dollarweed_drummer',
        mint: 'reinforce',
        cost: 150
    },
    {
        id: 'doom_shroom',
        mint: 'bombard',
        cost: 275
    },
    {
        id: 'fire_shroom',
        mint: 'peper',
        cost: 75
    },
    {
        id: 'flamewood',
        mint: 'appease',
        cost: 300
    },
    {
        id: 'future_star',
        mint: 'winter',
        cost: 125
    },
    {
        id: 'gatling_shooter',
        mint: 'appease',
        cost: 250
    },
    {
        id: 'gloom_shroom',
        mint: 'ail',
        cost: 150
    },
    {
        id: 'gold_magnet',
        mint: 'contain',
        cost: 50
    },
    {
        id: 'icy_fume_shroom',
        mint: 'winter',
        cost: 200
    },
    {
        id: 'imitater',
        mint: 'enchant',
        cost: 150
    },
    {
        id: 'kiwifruit',
        mint: 'contain',
        cost: 200
    },
    {
        id: 'lotus_shooter',
        mint: 'winter',
        cost: 200
    },
    {
        id: 'narcissus_shooter',
        mint: 'winter',
        cost: 300
    },
    {
        id: 'pickled_pepper',
        mint: 'peper',
        cost: 125
    },
    {
        id: 'scaredy_shroom',
        mint: 'ail',
        cost: 25
    },
    {
        id: 'shrinking_violet',
        mint: 'enchant',
        cost: 50
    },
    {
        id: 'stinger',
        mint: 'spear',
        cost: 125
    },
    {
        id: 'sunflower_singer',
        mint: 'enlighten',
        cost: 125
    },
    {
        id: 'super_chomper',
        mint: 'enforce',
        cost: 150
    },
    {
        id: 'vine_nut',
        mint: 'reinforce',
        cost: 250
    }
]

const OrangePlants = [
    {
        id: 'acidic_lemon',
        mint: 'ail',
        cost: 125
    },
    {
        id: 'angel_starfruit',
        mint: 'fila',
        cost: 225
    },
    {
        id: 'bamboo_trooper',
        mint: 'contain',
        cost: 200
    },
    {
        id: 'banana_launcher',
        mint: 'arma',
        cost: 500
    },
    {
        id: 'bearberry_mortar',
        mint: 'spear',
        cost: 150
    },
    {
        id: 'cactus',
        mint: 'spear',
        cost: 175
    },
    {
        id: 'cob_cannon',
        mint: 'arma',
        cost: 500
    },
    {
        id: 'duplicator_cycler',
        mint: 'enlighten',
        cost: 150
    },
    {
        id: 'eggplant_ninja',
        mint: 'spear',
        cost: 200
    },
    {
        id: 'ents',
        mint: 'reinforce',
        cost: 100
    },
    {
        id: 'frostbolt_shooter',
        mint: 'winter',
        cost: 200
    },
    {
        id: 'gatling_pea',
        mint: 'appease',
        cost: 375
    },
    {
        id: 'gloom_vine',
        mint: 'conceal',
        cost: 125
    },
    {
        id: 'grapeshot',
        mint: 'bombard',
        cost: 150
    },
    {
        id: 'dual_pistol_pinecone',
        mint: 'appease',
        cost: 175
    },
    {
        id: 'ice_shroom',
        mint: 'winter',
        cost: 175
    },
    {
        id: 'magic_shroom',
        mint: 'enchant',
        cost: 175
    },
    {
        id: 'mega_cattail',
        mint: 'spear',
        cost: 325
    },
    {
        id: 'mega_gatling_pea',
        mint: 'appease',
        cost: 400
    },
    {
        id: 'mulberry_blaster',
        mint: 'arma',
        cost: 150
    },
    {
        id: 'pomegranate',
        mint: 'arma',
        cost: 200
    },
    {
        id: 'snapdragon',
        mint: 'peper',
        cost: 150
    },
    {
        id: 'sun_shroom',
        mint: 'enlighten',
        cost: 25
    },
    {
        id: 'tile_turnip',
        mint: 'enchant',
        cost: 250
    },
    {
        id: 'time_stopper',
        mint: 'contain',
        cost: 50
    },
    {
        id: 'toxic_gloom_shroom',
        mint: 'ail',
        cost: 175
    },
    {
        id: 'triplet_sunflower',
        mint: 'enlighten',
        cost: 175
    },
    {
        id: 'winter_melon',
        mint: 'winter',
        cost: 500
    }
]

const SpecialPlants = [
    {
        id: 'weed',
        mint: 'weed',
        cost: 150
    },
    {
        id: 'pumpkin_weed',
        mint: 'weed',
        cost: 175
    },
    {
        id: 'terracotta_weed',
        mint: 'weed',
        cost: 200
    },
    {
        id: 'leaf_shield_weed',
        mint: 'weed',
        cost: 225
    },
    {
        id: 'wood_shield_weed',
        mint: 'weed',
        cost: 250
    },
    {
        id: 'vase_weed',
        mint: 'weed',
        cost: 275
    },
    {
        id: 'porcelain_vase_weed',
        mint: 'weed',
        cost: 300
    },
    {
        id: 'flag_weed',
        mint: 'weed',
        cost: 200
    },
    {
        id: 'heal_weed',
        mint: 'weed',
        cost: 200
    },
    {
        id: 'rock_pea',
        mint: 'appease',
        cost: 225
    },
    {
        id: 'sun_pharaoh',
        mint: 'enlighten',
        cost: 200
    },
    {
        id: 'wukong_pea',
        mint: 'appease',
        cost: 380
    }
]

const EnderPlants = [
    {
        id: 'acorn_blaster',
        mint: 'arma',
        cost: 200
    },
    {
        id: 'awaken_inky_cap',
        mint: 'ail',
        cost: 400
    },
    {
        id: 'bamboo_swordsman',
        mint: 'enforce',
        cost: 175
    },
    {
        id: 'bambusa',
        mint: 'spear',
        cost: 150
    },
    {
        id: 'bitter_gourd_bomb',
        mint: 'ail',
        cost: 200
    },
    {
        id: 'blue_leadwort',
        mint: 'enchant',
        cost: 200
    },
    {
        id: 'cherry_twins',
        mint: 'arma',
        cost: 250
    },
    {
        id: 'coconut_tree_guardian',
        mint: 'reinforce',
        cost: 150
    },
    {
        id: 'forklift_cypress',
        mint: 'spear',
        cost: 325
    },
    {
        id: 'heather_cracker',
        mint: 'enchant',
        cost: 200
    },
    {
        id: 'hover_chestnut',
        mint: 'bombard',
        cost: 250
    },
    {
        id: 'manjusaka',
        mint: 'enchant',
        cost: 325
    },
    {
        id: 'rocket_lemon_tree',
        mint: 'ail',
        cost: 325
    },
    {
        id: 'snow_wasabi',
        mint: 'winter',
        cost: 200
    },
    {
        id: 'soul_mirandy',
        mint: 'conceal',
        cost: 275
    },
    {
        id: 'walnut_boxer',
        mint: 'enforce',
        cost: 150
    }
]

world.beforeEvents.itemUse.subscribe(eventData => {
    const player = eventData.source
    if (eventData.itemStack.typeId == 'gpvz:suburban_almanac') {
        system.run(() => {
            plants(player)
            player.runCommand('scoreboard objectives add SunPoint dummy')
            player.runCommand(`scoreboard players add @s SunPoint 0`)
        })
    }
})

function rec(player, objective, min, max) {
    if (min == max) { return min }
    const middle = min + Math.floor((max - min) / 2)
    const p1 = world.getPlayers({ name: player.name, scoreOptions: [{ objective: objective, minScore: min, maxScore: middle }] })
    if (p1.length === 1) { return rec(player, objective, min, middle) }
    else { return rec(player, objective, middle + 1, max) }
}
function getScore(player, objective) {
    const p1 = world.getPlayers({ name: player.name, scoreOptions: [{ objective: objective, minScore: -2147483648, maxScore: 2147483647 }] })
    if (p1.length === 0) { return 0 }
    return rec(player, objective, -2147483648, 2147483647)
}

function plants(player) {
    let gui = new ActionFormData();
    const score = getScore(player, "SunPoint")
    gui.title({ rawtext: [{ "translate": "item.gpvz:suburban_almanac.name" }] })
    gui.body({ rawtext: [{ "translate": `sun.point.name`, with: [`${score}`] }] })
    gui.button({ rawtext: [{ "translate": "sun.exchange.name" }] }, 'textures/items/gpvz_sun_item.png')
    gui.button({ rawtext: [{ "translate": "white.plants.name" }] }, 'textures/items/puzzles/gpvz_puzzle_white.png')
    gui.button({ rawtext: [{ "translate": "green.plants.name" }] }, 'textures/items/puzzles/gpvz_puzzle_green.png')
    gui.button({ rawtext: [{ "translate": "blue.plants.name" }] }, 'textures/items/puzzles/gpvz_puzzle_blue.png')
    gui.button({ rawtext: [{ "translate": "purple.plants.name" }] }, 'textures/items/puzzles/gpvz_puzzle_purple.png')
    gui.button({ rawtext: [{ "translate": "orange.plants.name" }] }, 'textures/items/puzzles/gpvz_puzzle_orange.png')
    gui.button({ rawtext: [{ "translate": "special.plants.name" }] }, 'textures/items/puzzles/gpvz_puzzle_special.png')
    gui.button({ rawtext: [{ "translate": "ender.plants.name" }] }, 'textures/items/puzzles/gpvz_puzzle_ender.png')
    gui.show(player).then(result => {
        if (result.canceled) {
        }
        if (result.selection === 0) {
            sun(player);
        }
        if (result.selection === 1) {
            white(player);
        }
        if (result.selection === 2) {
            green(player);
        }
        if (result.selection === 3) {
            blue(player);
        }
        if (result.selection === 4) {
            purple(player);
        }
        if (result.selection === 5) {
            orange(player);
        }
        if (result.selection === 6) {
            special(player);
        }
        if (result.selection === 7) {
            ender(player);
        }
    })
}

function sun(player) {
    let form = new ModalFormData()
    const score = getScore(player, "SunPoint")
    form.title({ rawtext: [{ "translate": `sun.point.name`, with: [`${score}`] }] })
    form.slider({
        rawtext: [
            { "translate": `sun.exchange.body` },
            { text: "\n\n" },
            { "translate": "almanac.shop.buy" }
        ]
    }, 1, 64, 1)
    form.toggle({ rawtext: [{ "translate": `shop.buy.sell` }] }, false)
    form.show(player).then(formData => {
        if (formData.canceled) {
            plants(player)
        } else {
            let dataCost = 50 * formData.formValues[0]
            let dataSell = 50 * formData.formValues[0]
            if (formData.formValues[1] == true) {
                player.runCommand(`execute if entity @s[hasitem={item=gpvz:sun_item,quantity=!${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.failed" } ] }`)
                player.runCommand(`execute if entity @s[hasitem={item=gpvz:sun_item,quantity=${formData.formValues[0]}..}] run scoreboard players add @s SunPoint ${dataSell}`)
                player.runCommand(`execute if entity @s[hasitem={item=gpvz:sun_item,quantity=${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.succeed" } ] }`)
                player.runCommand(`execute if entity @s[hasitem={item=gpvz:sun_item,quantity=${formData.formValues[0]}..}] run clear @s gpvz:sun_item 0 ${formData.formValues[0]}`)
            }
            if (formData.formValues[1] == false) {
                player.runCommand(`execute if entity @s[scores={SunPoint=!${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.failed" } ] }`)
                player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run give @s gpvz:sun_item ${formData.formValues[0]} 0`)
                player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.succeed" } ] }`)
                player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run scoreboard players remove @s SunPoint ${dataCost}`)
            }
        }
    })
}

function white(player) {
    let gui = new ActionFormData();
    gui.title('✣ CHOOSE YOUR CARDS ✣')
    gui.body('')
    for (const item of WhitePlants)
        gui.button({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] }, `textures/items/seedpackets/gpvz_${item.id}_seedpacket`);
    gui.show(player).then(result => {
        if (result.canceled) {
            plants(player)
        }
        else if (result.selection < WhitePlants.length) {
            const item = WhitePlants[result.selection];
            const score = getScore(player, "SunPoint")
            let form = new ModalFormData()
            form.title({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] })
            form.slider({
                rawtext: [
                    { "translate": `almanac.${item.id}.entry` },
                    { text: "\n\n" },
                    { "translate": `almanac.plant.cost`, with: [`${item.cost}`] },
                    { text: "\n\n" },
                    { "translate": `${item.mint}.mint.name` },
                    { text: "\n\n" },
                    { "translate": `sun.point.name`, with: [`${score}`] },
                    { "translate": `plants.sell.name` },
                    { text: "\n\n" },
                    { "translate": "almanac.shop.buy" }
                ]
            }, 1, 64, 1),
                form.toggle({ rawtext: [{ "translate": `shop.buy.sell` }] }, false)
            form.show(player).then(formData => {
                if (formData.canceled) {
                    white(player)
                } else {
                    let dataCost = item.cost * formData.formValues[0]
                    let dataSell = item.cost * formData.formValues[0]
                    if (formData.formValues[1] == true) {
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=!${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.failed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run scoreboard players add @s SunPoint ${dataSell}`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run clear @s gpvz:${item.id}_seedpacket 0 ${formData.formValues[0]}`)
                    }
                    if (formData.formValues[1] == false) {
                        player.runCommand(`execute if entity @s[scores={SunPoint=!${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.failed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run give @s gpvz:${item.id}_seedpacket ${formData.formValues[0]} 0`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run scoreboard players remove @s SunPoint ${dataCost}`)
                    }
                }
            })
        }
    });
}

function green(player) {
    let gui = new ActionFormData();
    gui.title('✣ CHOOSE YOUR CARDS ✣')
    gui.body('')
    for (const item of GreenPlants)
        gui.button({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] }, `textures/items/seedpackets/gpvz_${item.id}_seedpacket`);
    gui.show(player).then(result => {
        if (result.canceled) {
            plants(player)
        }
        else if (result.selection < GreenPlants.length) {
            const item = GreenPlants[result.selection];
            const score = getScore(player, "SunPoint")
            let form = new ModalFormData()
            form.title({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] })
            form.slider({
                rawtext: [
                    { "translate": `almanac.${item.id}.entry` },
                    { text: "\n\n" },
                    { "translate": `almanac.plant.cost`, with: [`${item.cost}`] },
                    { text: "\n\n" },
                    { "translate": `${item.mint}.mint.name` },
                    { text: "\n\n" },
                    { "translate": `sun.point.name`, with: [`${score}`] },
                    { "translate": `plants.sell.name` },
                    { text: "\n\n" },
                    { "translate": "almanac.shop.buy" }
                ]
            }, 1, 64, 1),
                form.toggle({ rawtext: [{ "translate": `shop.buy.sell` }] }, false)
            form.show(player).then(formData => {
                if (formData.canceled) {
                    green(player)
                } else {
                    let dataCost = item.cost * formData.formValues[0]
                    let dataSell = item.cost * formData.formValues[0]
                    if (formData.formValues[1] == true) {
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=!${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.failed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run scoreboard players add @s SunPoint ${dataSell}`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run clear @s gpvz:${item.id}_seedpacket 0 ${formData.formValues[0]}`)
                    }
                    if (formData.formValues[1] == false) {
                        player.runCommand(`execute if entity @s[scores={SunPoint=!${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.failed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run give @s gpvz:${item.id}_seedpacket ${formData.formValues[0]} 0`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run scoreboard players remove @s SunPoint ${dataCost}`)
                    }
                }
            })
        }
    });
}

function blue(player) {
    let gui = new ActionFormData();
    gui.title('✣ CHOOSE YOUR CARDS ✣')
    gui.body('')
    for (const item of BluePlants)
        gui.button({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] }, `textures/items/seedpackets/gpvz_${item.id}_seedpacket`);
    gui.show(player).then(result => {
        if (result.canceled) {
            plants(player)
        }
        else if (result.selection < BluePlants.length) {
            const item = BluePlants[result.selection];
            const score = getScore(player, "SunPoint")
            let form = new ModalFormData()
            form.title({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] })
            form.slider({
                rawtext: [
                    { "translate": `almanac.${item.id}.entry` },
                    { text: "\n\n" },
                    { "translate": `almanac.plant.cost`, with: [`${item.cost}`] },
                    { text: "\n\n" },
                    { "translate": `${item.mint}.mint.name` },
                    { text: "\n\n" },
                    { "translate": `sun.point.name`, with: [`${score}`] },
                    { "translate": `plants.sell.name` },
                    { text: "\n\n" },
                    { "translate": "almanac.shop.buy" }
                ]
            }, 1, 64, 1),
                form.toggle({ rawtext: [{ "translate": `shop.buy.sell` }] }, false)
            form.show(player).then(formData => {
                if (formData.canceled) {
                    blue(player)
                } else {
                    let dataCost = item.cost * formData.formValues[0]
                    let dataSell = item.cost * formData.formValues[0]
                    if (formData.formValues[1] == true) {
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=!${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.failed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run scoreboard players add @s SunPoint ${dataSell}`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run clear @s gpvz:${item.id}_seedpacket 0 ${formData.formValues[0]}`)
                    }
                    if (formData.formValues[1] == false) {
                        player.runCommand(`execute if entity @s[scores={SunPoint=!${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.failed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run give @s gpvz:${item.id}_seedpacket ${formData.formValues[0]} 0`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run scoreboard players remove @s SunPoint ${dataCost}`)
                    }
                }
            })
        }
    });
}

function purple(player) {
    let gui = new ActionFormData();
    gui.title('✣ CHOOSE YOUR CARDS ✣')
    gui.body('')
    for (const item of PurplePlants)
        gui.button({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] }, `textures/items/seedpackets/gpvz_${item.id}_seedpacket`);
    gui.show(player).then(result => {
        if (result.canceled) {
            plants(player)
        }
        else if (result.selection < PurplePlants.length) {
            const item = PurplePlants[result.selection];
            const score = getScore(player, "SunPoint")
            let form = new ModalFormData()
            form.title({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] })
            form.slider({
                rawtext: [
                    { "translate": `almanac.${item.id}.entry` },
                    { text: "\n\n" },
                    { "translate": `almanac.plant.cost`, with: [`${item.cost}`] },
                    { text: "\n\n" },
                    { "translate": `${item.mint}.mint.name` },
                    { text: "\n\n" },
                    { "translate": `sun.point.name`, with: [`${score}`] },
                    { "translate": `plants.sell.name` },
                    { text: "\n\n" },
                    { "translate": "almanac.shop.buy" }
                ]
            }, 1, 64, 1),
                form.toggle({ rawtext: [{ "translate": `shop.buy.sell` }] }, false)
            form.show(player).then(formData => {
                if (formData.canceled) {
                    purple(player)
                } else {
                    let dataCost = item.cost * formData.formValues[0]
                    let dataSell = item.cost * formData.formValues[0]
                    if (formData.formValues[1] == true) {
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=!${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.failed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run scoreboard players add @s SunPoint ${dataSell}`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run clear @s gpvz:${item.id}_seedpacket 0 ${formData.formValues[0]}`)
                    }
                    if (formData.formValues[1] == false) {
                        player.runCommand(`execute if entity @s[scores={SunPoint=!${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.failed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run give @s gpvz:${item.id}_seedpacket ${formData.formValues[0]} 0`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run scoreboard players remove @s SunPoint ${dataCost}`)
                    }
                }
            })
        }
    });
}

function orange(player) {
    let gui = new ActionFormData();
    gui.title('✣ CHOOSE YOUR CARDS ✣')
    gui.body('')
    for (const item of OrangePlants)
        gui.button({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] }, `textures/items/seedpackets/gpvz_${item.id}_seedpacket`);
    gui.show(player).then(result => {
        if (result.canceled) {
            plants(player)
        }
        else if (result.selection < OrangePlants.length) {
            const item = OrangePlants[result.selection];
            const score = getScore(player, "SunPoint")
            let form = new ModalFormData()
            form.title({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] })
            form.slider({
                rawtext: [
                    { "translate": `almanac.${item.id}.entry` },
                    { text: "\n\n" },
                    { "translate": `almanac.plant.cost`, with: [`${item.cost}`] },
                    { text: "\n\n" },
                    { "translate": `${item.mint}.mint.name` },
                    { text: "\n\n" },
                    { "translate": `sun.point.name`, with: [`${score}`] },
                    { "translate": `plants.sell.name` },
                    { text: "\n\n" },
                    { "translate": "almanac.shop.buy" }
                ]
            }, 1, 64, 1),
                form.toggle({ rawtext: [{ "translate": `shop.buy.sell` }] }, false)
            form.show(player).then(formData => {
                if (formData.canceled) {
                    orange(player)
                } else {
                    let dataCost = item.cost * formData.formValues[0]
                    let dataSell = item.cost * formData.formValues[0]
                    if (formData.formValues[1] == true) {
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=!${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.failed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run scoreboard players add @s SunPoint ${dataSell}`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run clear @s gpvz:${item.id}_seedpacket 0 ${formData.formValues[0]}`)
                    }
                    if (formData.formValues[1] == false) {
                        player.runCommand(`execute if entity @s[scores={SunPoint=!${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.failed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run give @s gpvz:${item.id}_seedpacket ${formData.formValues[0]} 0`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run scoreboard players remove @s SunPoint ${dataCost}`)
                    }
                }
            })
        }
    });
}

function special(player) {
    let gui = new ActionFormData();
    gui.title('✣ CHOOSE YOUR CARDS ✣')
    gui.body('')
    for (const item of SpecialPlants)
        gui.button({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] }, `textures/items/special/gpvz_${item.id}_seedpacket`);
    gui.show(player).then(result => {
        if (result.canceled) {
            plants(player)
        }
        else if (result.selection < SpecialPlants.length) {
            const item = SpecialPlants[result.selection];
            const score = getScore(player, "SunPoint")
            let form = new ModalFormData()
            form.title({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] })
            form.slider({
                rawtext: [
                    { "translate": `almanac.${item.id}.entry` },
                    { text: "\n\n" },
                    { "translate": `almanac.plant.cost`, with: [`${item.cost}`] },
                    { text: "\n\n" },
                    { "translate": `${item.mint}.mint.name` },
                    { text: "\n\n" },
                    { "translate": `sun.point.name`, with: [`${score}`] },
                    { "translate": `plants.sell.name` },
                    { text: "\n\n" },
                    { "translate": "almanac.shop.buy" }
                ]
            }, 1, 64, 1),
                form.toggle({ rawtext: [{ "translate": `shop.buy.sell` }] }, false)
            form.show(player).then(formData => {
                if (formData.canceled) {
                    special(player)
                } else {
                    let dataCost = item.cost * formData.formValues[0]
                    let dataSell = item.cost * formData.formValues[0]
                    if (formData.formValues[1] == true) {
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=!${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.failed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run scoreboard players add @s SunPoint ${dataSell}`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run clear @s gpvz:${item.id}_seedpacket 0 ${formData.formValues[0]}`)
                    }
                    if (formData.formValues[1] == false) {
                        player.runCommand(`execute if entity @s[scores={SunPoint=!${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.failed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run give @s gpvz:${item.id}_seedpacket ${formData.formValues[0]} 0`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run scoreboard players remove @s SunPoint ${dataCost}`)
                    }
                }
            })
        }
    });
}

function ender(player) {
    let gui = new ActionFormData();
    gui.title('✣ CHOOSE YOUR CARDS ✣')
    gui.body('')
    for (const item of EnderPlants)
        gui.button({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] }, `textures/items/seedpackets/gpvz_${item.id}_seedpacket`);
    gui.show(player).then(result => {
        if (result.canceled) {
            plants(player)
        }
        else if (result.selection < EnderPlants.length) {
            const item = EnderPlants[result.selection];
            const score = getScore(player, "SunPoint")
            let form = new ModalFormData()
            form.title({ rawtext: [{ "translate": `entity.gpvz:${item.id}.name` }] })
            form.slider({
                rawtext: [
                    { "translate": `almanac.ender.plant` },
                    { text: "\n\n" },
                    { "translate": `almanac.${item.id}.entry` },
                    { text: "\n\n" },
                    { "translate": `almanac.plant.cost`, with: [`${item.cost}`] },
                    { text: "\n\n" },
                    { "translate": `${item.mint}.mint.name` },
                    { text: "\n\n" },
                    { "translate": `sun.point.name`, with: [`${score}`] },
                    { "translate": `plants.sell.name` },
                    { text: "\n\n" },
                    { "translate": "almanac.shop.buy" }
                ]
            }, 1, 64, 1),
                form.toggle({ rawtext: [{ "translate": `shop.buy.sell` }] }, false)
            form.show(player).then(formData => {
                if (formData.canceled) {
                    ender(player)
                } else {
                    let dataCost = item.cost * formData.formValues[0]
                    let dataSell = item.cost * formData.formValues[0]
                    if (formData.formValues[1] == true) {
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=!${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.failed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run scoreboard players add @s SunPoint ${dataSell}`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run tellraw @s { "rawtext": [ { "translate": "shop.sell.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[hasitem={item=gpvz:${item.id}_seedpacket,quantity=${formData.formValues[0]}..}] run clear @s gpvz:${item.id}_seedpacket 0 ${formData.formValues[0]}`)
                    }
                    if (formData.formValues[1] == false) {
                        player.runCommand(`execute if entity @s[scores={SunPoint=!${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.failed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run give @s gpvz:${item.id}_seedpacket ${formData.formValues[0]} 0`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run tellraw @s { "rawtext": [ { "translate": "shop.buy.succeed" } ] }`)
                        player.runCommand(`execute if entity @s[scores={SunPoint=${dataCost}..}] run scoreboard players remove @s SunPoint ${dataCost}`)
                    }
                }
            })
        }
    });
}